package za.ac.sun.cs.solver.csp;

import java.util.HashMap;
import java.util.List;

import za.ac.sun.cs.solver.expr.Expression;
import za.ac.sun.cs.solver.expr.Variable;

public interface ConstraintSolver {

	public HashMap<Variable, Object> getVariableMap(Expression expression);
	
	public HashMap<Variable, Object> getNextVariableMap(); // added by bihuan

	public Integer getIntValue(Variable variable);

	public Double getRealValue(Variable variable);

	/**
	 * Returns a list of "report" lines about the performance of the constraint solver.
	 * 
	 * @return lines of a performance report
	 */
	public List<String> getConstraintSolverReport();

}
